#! /usr/bin/perl 
use DBI; 
my $driver_name;
my $db_name;
my $data_source; 
my $drh = "Driverhandler";
my $dbh = "Databasehandler";
my $sth = "StatementHandler";
my $output;

#my $local_user = getlogin();
my $Error_Log = "./DbIerror.log";
print "Content-type: text/html \n\n";

# Redirect STDERR
open (STDERR,">>$Error_Log") || \
    print "Could not open $Error_Log";

# Redirect %SIG{}
#$SIG{INT} = "interrupt"; 
$SIG{__WARN__} = "warning";
$SIG{__DIE__} = "dying";
$SIG{QUIT} = "IGNORE";

%QUERY = prepareInput($ENV{'QUERY_STRING'});

#All available drivers
@driver_names = DBI->available_drivers;

$driver_name = $QUERY{"driver_name"};
#Try to load Driver
#$drh = DBI->install_driver($driver_name) or $output = $output."$DBI::errstr";

if ($driver_name ne ""){
	# All available Dbs on localhost with selected driver
	$host_name = $QUERY{"host_name"};
	if (1){#$host_name eq ""){
		@data_sources = DBI->data_sources($driver_name) or $output = $output."Error using Driver $driver_name: $DBI::errstr\n";
	}else{
		@datasources[0] = "NA";
	}

	# Connection String -> data_source
	#datasource syntax (dbi:DriverName:database-name;host=host;port=port)
	$db_name = $QUERY{"db_name"};
	$host_name = $QUERY{"host_name"};
	$host_port = $QUERY{"host_port"};
  	if ($hostname eq "" or $host_port eq ""){
		$data_source = "dbi:$driver_name:$db_name";
        }else{
	        $data_source = "dbi:$driver_name:$db_name;host=$host_name;port=$host_port";
	}
	
        $username=$QUERY{"username"};
	$password=$QUERY{"password"};
	# "Try to connect DBMS: $data_source \n";
	$dbh = DBI->connect($data_source, $username, $password) or $output = $output."Connect to $data_source failed\n$DBI::errstr\n";
	# "DBMS $data_source connected\n";

	$query = $QUERY{"query"};
	if ($dbh){
		# Make Statement
		$sth = $dbh->prepare($query) or $output = $output."$DBI::errstr\n";
		$result = $sth->execute or $output = $output."$DBI::errstr\n";
		@names = @{$sth->{NAME}};
        	$output = $output."@names\n";
		@types = @{$sth->{TYPE}};
		foreach $type (@types){
			%type = %{$dbh->type_info($type)};
			$output = $output."$type{TYPE_NAME}:$type{LOCAL_TYPE_NAME}   $type{COLUMN_SIZE}  $type{NULLABLE}  $type{AUTO_UNIQUE_VALUE}\n";
    			$output = $output."\n";
		}
		while ( @row = $sth->fetchrow() ) {
    			$output = $output."@row\n";
		}
	}
}
#printHtml(@driver_names, $dbms_name, @data_sources, $host_name, $host_port, $username, $password, $output2);

sub getInput{
    print $_[0];
    $in = <STDIN>;
    $in =~s/\n//go;
    return $in; 
}

sub interrupt{
    local ($signal) = @_;
    local $time = localtime();
    print STDERR "$time\nDenying interruption: $signal\n";
    $SIG{INT} = "interrupt";
}

sub warning{
    local ($signal) = @_;
    local $time = localtime();
    print STDERR "$time: $signal\n";
    $SIG{__WARN__} = "warning";
}

sub dying{
    local ($signal) = @_;
    local $time = localtime();
    print STDERR "$time\n$signal";
    print "$time\nProcess aborted because: $signal";
    $SIG{__DIE__} = "dying";
}

sub prepareInput {
	local $inputdaten, $name, $daten;
	local @inputliste;
	local %inputhash;
	
	$inputdaten = $_[0];
        $inputdaten =~ s/\%(..)/pack("c",hex($1))/ge;
	@inputliste = split(/[&;]/ ,$inputdaten);
	foreach $eintrag(@inputliste){
		$eintrag =~ s/\+/ /go;
		#$eintrag =~ s/\%(..)/pack("c",hex($1))/ge;
		($name, $daten) = split( /=/ ,$eintrag);
		#$name =~ s/\%(..)/pack("c",hex($1))/ge;
		#$daten =~ s/\%(..)/pack("c",hex($1))/ge;
		$inputhash{$name} = ($daten);
	}
	return %inputhash;
}

#sub printHtml{
#local @driver_names = $_[0];
#$dbms_name, $db_names, $host_name, $host_port, $username, $password, $output) = @_;
if ($output eq ""){
	$output = "No Errors";
	$query = "";
}
print <<"SHAG";
<html>
<head>
<meta name="generator" content="DbI">
<title>Database Independent Web Interface</title>
</head>
<body>
<table border="4" cellpadding="0" cellspacing="2" width="200" bgcolor="#afafaf">
<tr>
<td>Driver:</td>
<form action=DbI.pl>
<td align="right"><select name="driver_name" size="1">
SHAG
foreach $foo (sort @driver_names){
        if ($driver_name eq $foo){
		print "<option selected>$foo\n";
	}else{
		print "<option >$foo\n";
	}
}
print <<"SHAG";
</select></td>
<td rowspan="7"><textarea name="output" cols="30" rows="12">$output</textarea></td>
</tr>
<tr>
<td>Dbms:</td>
<td align="right"><select name="dbms_name" size="1">
</select></td>
</tr>
<tr>
<td>Database:</td>
<td align="right"><input type="text" name="db_name" size="10" value="$db_name"></td>
</tr>
<tr>
<td>Host:</td>
<td align="right"><input type="text" name="host_name" size="10" value="$host_name"></td>
</tr>
<tr>
<td>Port:</td>
<td align="right"><input type="text" name="host_port" size="10" value="$host_port"></td>
</tr>
<tr>
<td>User:</td>
<td align="right"><input type="text" name="username" size="10" value="$username"></td>
</tr>
<tr>
<td>Password:</td>
<td align="right"><input type="password" name="password" size="10" value="$password"></td>
</tr>
<tr>
<td>Known Dbs<br>
SHAG
foreach $data_source (sort @data_sources){
    print "$data_source<br>";
}
print <<"SHAG";
</td>
<td align="right">SQL:</td>
<td><form action=test><input type="text" name="query" size="32" value="$query"><br><input type=submit value="pansen"></form></td>
</tr>
</table>
</body>
</html>
SHAG
#}